//
//  TLCLog for iOS
//
//  Created by NHN Business Platform.
//  Copyright (c) 2012 NHN Business Platform. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface TLCLog : NSObject

typedef enum
{
    TLCLogProtocolHttps,
    TLCLogProtocolHttp
} TLCLogProtocol;


// common
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion enableSyncStart:(bool)syncFlag;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enableSyncStart:(bool)syncFlag;

+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId forHandleId:(NSString*)handleId;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId forHandleId:(NSString*)handleId enableSyncStart:(bool)syncFlag;

+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version enableSyncStart:(bool)syncFlag;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId enableSyncStart:(bool)syncFlag;

+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId forHandleId:(NSString*)handleId;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId forHandleId:(NSString*)handleId enableSyncStart:(bool)syncFlag;

+ (void) debug:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) error:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) fatal:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) info:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) warn:(NSString*)errorCode withMessage:(NSString*)message;

+ (void) debug:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) error:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) fatal:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) info:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) warn:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;

+ (void) setDebugMode:(bool)flag;

+ (void) removeAllCustomFields;
+ (void) removeCustomFieldForKey:(NSString*)key;
+ (void) setCustomField:(NSString*)value forKey:(NSString*)key;
+ (void) startSendThread;

+ (void) setUserId:(NSString*)userId;
+ (void) setLogType:(NSString*)logType;
+ (void) setLogSource:(NSString*) logSource;
+ (void) setCrashBlock:(void (^)(void))block;
+ (void) setLogDeduplicate:(bool)flag;

+ (void) enableHost:(bool)flag;

+ (int) queueSize;
+ (int) fileQueueSize;

+ (NSString *) sdkVersion;


#if UNITY
// unity
#ifdef __cplusplus
extern "C" {
#endif
    void UnitySendMessage(const char* obj, const char* method, const char* msg);
#ifdef __cplusplus
}
#endif

#endif

// for unity
+ (void) handledDebug:(NSString*)message withException:(NSString*)exception;
+ (void) handledError:(NSString*)message withException:(NSString*)exception;
+ (void) handledFatal:(NSString*)message withException:(NSString*)exception;
+ (void) handledInfo:(NSString*)message withException:(NSString*)exception;
+ (void) handledWarn:(NSString*)message withException:(NSString*)exception;

+ (void) sendUnityCrash:(NSString*)logLevel withType:(NSString*)logType withMessage:(NSString*)message withException:(NSString*)exception;

+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag enableSyncStart:(bool)syncFlag;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag enableSyncStart:(bool)syncFlag withUnityVersion:(NSString*)UnityVersion;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag enableSyncStart:(bool)syncFlag withUnityVersion:(NSString*)UnityVersion forHandleId:(NSString*)handleId;


#ifdef APPGUARD
// appguard
+ (void) debug_Appguard:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) error_Appguard:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) fatal_Appguard:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) info_Appguard:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) warn_Appguard:(NSString*)errorCode withMessage:(NSString*)message;

+ (void) debug_Appguard:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) error_Appguard:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) fatal_Appguard:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) info_Appguard:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) warn_Appguard:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;

+ (void) removeAllCustomFields_AppGuard;
+ (void) removeCustomFieldForKey_AppGuard:(NSString*)key;
+ (void) setCustomField_AppGuard:(NSString*)value forKey:(NSString*)key;

+ (void) setUserId_AppGuard:(NSString*)userId;
+ (void) setLogType_AppGuard:(NSString*)logType;
+ (void) setLogSource_AppGuard:(NSString*) logSource;
+ (void) setLogDeduplicate_AppGuard:(bool)flag;
#endif 


@end
